public class Comparison<T extends Comparable> {

    private T op1, op2;

    public Comparison( T op1, T op2 )
    {
        this.op1 = op1;
        this.op2 = op2;
    }

    public Comparison()
    {
        this( null, null );
    }

    public T getOp1()
    {
        return op1;
    }

    public void setOp1( T op1 )
    {
        this.op1 = op1;
    }

    public T getOp2()
    {
        return op2;
    }

    public void setOp2( T op2 )
    {
        this.op2 = op2;
    }

    public T max()
    {
        return op1.compareTo( op2 ) > 0 ? op1 : op2;
    }

    public static <T extends Comparable> T max( T a, T b )
    {
        return a.compareTo( b ) > 0 ? a : b;
    }

    public static <T extends Comparable<T>> T max2( T a, T b )
    {
        return a.compareTo( b ) > 0 ? a : b;
    }

    public static void main( String args[] )
    {
        Comparison<Integer> c1 = new Comparison<Integer>();
        c1.setOp1( 20 );
        c1.setOp2( 10 );
        System.out.println( c1.max() );

        Comparison<String> c2 = new Comparison<String>( "hello", "world" );
        System.out.println( c2.max() );

        // System.out.println( Comparison.max(10, "20") ); // runtime error!
        // System.out.println( Comparison.max2(10,"20") ); // compilation error!
        System.out.println( Comparison.max2( 10, 20 ) ); // no error!
    }

}
